<template>
  <div>
    <v-dialog v-model="mostrarDialogoNuevaVersion" persistent max-width="1200">
      <v-card>
        <div class="btnCerrarModal" @click="cancelarAlerta">
          <div>X</div>
        </div>
        <NuevaVersionComponent
          v-if="mostrarDialogoNuevaVersion"
          v-model="value"
          :itemSeleccionado="itemSeleccionado"
          :callbackNuevaVersionComponent="callbackNuevaVersionComponent"
          ref="nuevaVersionComponent"
        />
      </v-card>
    </v-dialog>
    <v-dialog v-model="mostrarPDFAlert" persistent max-width="1200">
      <v-card>
        <div class="btnCerrarModal" @click="cancelarPDFAlert">
          <div>X</div>
        </div>
        <VisualizadorPDFComponent
          v-if="mostrarPDFAlert"
          v-model="datos"
          ref="visualizadorPDFComponent"
        />
      </v-card>
    </v-dialog>

    <div class="titSec">Resultado de Búsqueda</div>
    <v-card style="background-color: #fafafa">
      <div class="gris" style="margin-top: 15px">
        <v-data-table
          :headers="headers"
          :items="items"
          item-key="idFolio"
          :loading="loading"
          :dense="true"
          :fixed-header="true"
          class="custom-table"
          hide-default-footer
        >
          <template v-slot:item.fecha="{ item }" }>
            {{ formatDate(item.fecha) }}</template
          >
          <template v-slot:item.verArchivo="{ item }" }>
            <div class="link" @click="redirecciona(item.ruta, item.idFolio)">
              Ver Archivo
            </div>
          </template>
          <template v-slot:item.nuevaVersion="{ item }" }>
            <div class="link" @click="redireccionaCreaVersion(item)">
              Crear versión
            </div></template
          >
          <template v-slot:item.descargar="{ item }" }>
            <div
              class="link"
              @click="
                descargar(
                  item.ruta,
                  item.idFolio,
                  item.nombreArchivo,
                  item.extension
                )
              "
            >
              Descargar
            </div>
            <a id="dwnldLnk" download="nombre.pdf" style="display: none" />
          </template>
        </v-data-table>
      </div>
    </v-card>
  </div>
</template>
<style scoped>
.publicado--text {
  color: #4fd495;
}
.revisar--text {
  color: #fdae31;
}
.autorizar--text {
  color: #feb94b;
}
.documentar--text {
  color: #fad743;
}
.link {
  text-decoration: underline;
  color: black;
  cursor: pointer;
}
.float-rigth.v-btn {
  float: right;
}
.float-left {
  float: left;
}
</style>
<style>
.publicado--text {
  color: #4fd495;
}
.revisar--text {
  color: #fdae31;
}
.autorizar--text {
  color: #feb94b;
}
.documentar--text {
  color: #fad743;
}
.link {
  text-decoration: underline;
  color: black;
  cursor: pointer;
}
.float-rigth.v-btn {
  float: right;
}
.float-left {
  float: left;
}
</style>
<style>
.theme--light.v-data-table.v-data-table--fixed-header thead {
  border-bottom: #ffcd00 3px solid;
}
.theme--light.v-data-table.v-data-table--fixed-header thead th {
  background-color: #fafafa;
}
div.custom-table div table tbody tr:nth-child(odd) {
  background-color: #fafafa;
}

div.custom-table div table tbody tr:nth-child(even) {
  background-color: #f0f0f0;
}

div.custom-table div table tbody tr:hover {
  background-color: #ffcd0059 !important;
}
div.custom-table .t-footer {
  background-color: #fafafa;
}
.v-data-table.custom-table.theme--light.v-data-table {
  background-color: #fafafa;
}
</style>
<script>
import store from "@/store";
import router from "@/router";
import moment from "moment";
import NuevaVersionComponent from "./NuevaVersionComponent.vue";
import VisualizadorPDFComponent from "../componentes/VisualizadorPDFComponent.vue";
const axios = store.state.axiosApiLocal;
export default {
  props: {
    value: Object,
  },
  components: { NuevaVersionComponent, VisualizadorPDFComponent },
  name: "infraestructura_layouts_documentos",

  data: (vm) => ({
    data: [],
    itemSeleccionado: null,
    mostrarDialogoNuevaVersion: false,
    mostrarPDFAlert: false,
    datos: {
      uuid: "",
      folio: "",
    },
    loading: false,
    headers: [
      { text: "Nombre", value: "nombreArchivo", align: "center" },
      { text: "Formato", value: "nombreFormato", align: "center" },
      { text: "Proyecto", value: "nombreProyecto", align: "center" },
      { text: "Documento", value: "nombreDocumento", align: "center" },
      { text: "Tipo de Archivo", value: "extension", align: "center" },
      { text: "Fecha", value: "fecha", align: "center" },
      { text: "Version", value: "idVersion", align: "center" },
      { text: "Ver Archivo", value: "verArchivo", aligin: "center" },
      //{ text: "Listado de Versiones",  value: "listadoVersiones", aligin: "center", },
      { text: "Nueva Version", value: "nuevaVersion", aligin: "center" },
      { text: "Descargar", value: "descargar", aligin: "center" },
    ],
    items: [],
    itemsAll: [],
    itemsP: [],
  }),
  mounted() {
    this.callBackCeco();
  },
  methods: {
    formatDate(date) {
      return moment(date).format("DD-MM-YYYY");
    },
    save(date) {
      this.$refs.menu.save(date);
    },
    callBackCeco() {
      var ceco = this.value.dataCeco.ceco;
      var self = this;
      self.items = [];
      axios(
        "/documento-sucursal/virtuales-archivos/v1/virtuales/archivos/ceco/" +
          ceco
      )
        .then((response) => {
          let data = response.data;
          if (data) {
            self.items = data.resultado.archivosCentroCosto;
            console.log("Antes de filtrar=>" + JSON.stringify(self.items));
            self.itemsAll = self.items;
            this.filtrarItems();
          }
        })
        .catch((error) => {
          if (error.response) {
            console.log(error.response.data);
          }
        });
    },
    filtrarItems() {
      if (this.items && this.items.length > 0) {
        var idFormato = this.value.dataFormato.value.idFormato;
        var idProyecto = this.value.dataProyecto.value.idProyecto;
        var idDocumento = this.value.dataDocumento.value.idDocumento;
        this.items = this.items.filter(
          (item) =>
            item.idFormato == idFormato &&
            item.idProyecto == idProyecto &&
            item.idDocumento == idDocumento
        );
      }

      console.log("Filtrado==>" + JSON.stringify(this.items));
    },

    redirecciona(uuid, folio) {
      this.datos.uuid = uuid;
      this.datos.folio = folio;
      this.mostrarPDFAlert = true;
    },
    cancelarAlerta() {
      this.mostrarDialogoNuevaVersion = false;
    },
    cancelarPDFAlert() {
      this.mostrarPDFAlert = false;
    },
    callbackNuevaVersionComponent() {
      this.cancelarAlerta();
      this.callBackCeco();
    },
    redireccionaCreaVersion(itemSeleccionado) {
      this.itemSeleccionado = itemSeleccionado;
      this.mostrarDialogoNuevaVersion = true;
    },
    descargar(uuid, folio, nombre, extencion) {
      const self = this;
      axios(
        "/documento-sucursal/archivos/v1/" +
          folio +
          "/archivos/" +
          uuid +
          "/contenido"
      )
        .then((response) => {
          let data = response.data;
          if (data) {
            let initialDoc = data.resultado.archivo;

            var dlnk = document.getElementById("dwnldLnk");

            dlnk.href = initialDoc;
            if (extencion == "dwg") {
              dlnk.download = nombre.split(".")[0] + "." + extencion;
            } else {
              dlnk.download = nombre.split(".")[0] + ".pdf";
            }

            dlnk.click();
          }
        })
        .catch((error) => {
          if (error.response) {
            console.log(error.response.data);
          }
        });
    },
  },
};
</script>
